=== mpi_include/Makefile ===

all:
	$(FC) -c mpi.f90

clean:
	rm -rf *.mod *.o
