=== tests/f90int_file/CMakeLists.txt ===
setup_f90_test(f90int_file hello.F90)
