=== tests/f90issue6/CMakeLists.txt ===
setup_f90_test(f90issue6 f90issue6.F90)
